#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#if !defined(WINDOWS64)
#include <termios.h>
#include <sys/ioctl.h>
#endif

#include "itqA.h"
#include "vecmath.h"
#include "itq-typedefs.h"
#include "accuminfo.h"

//
// This is crappy code mostly meant for display of internal state for debugging
// purposes.  It has become a little more useful that that, but is still very ugly
// and fairly poorly implemented for production code.
//

compstats
	INst,
	OUTst;

int nDLBYA = 0;
dlbystats DLBYAst[MAXnDLBYA];

extern int numexp;

namespace accuminfo
{
	int cursample;
	int curlongsample;
	int totalaudiosamples;
	long long int currentaudiosample;

#define LEVELDPY 0
	void __attribute__((noinline))
	accumulatelevel(const Asample& sample, int& totals, int& limit99, int& limit70, int& limit50, int& limit25)
	{

#if defined(LEVELDPY) && (LEVELDPY > 0)
		bool lastcrlf = false;
#endif
		if ((ac.info == 0) || (ac.info > 10000))
			return;
		float newvalue = sample.sumsq();


		if (curlongsample >= longsamplesavg())
		{
				float nsamps = float(curlongsample);

				float fs = GBLfslevel;
				float fsdB= lin2dB(fs);
				//float pldB= ac.agcpvtlevel;
				float pldB= fsdB;
				float inoutrefdB = fsdB;

				//
				// We have a 3dB RMS correction because of peak vs. stereo.
				//
				float INrms = INst.getsumsq() / nsamps;
				float dBINrms = (lin2dB(INrms) / 2.0f) - 3.0f;

				float OUTrms = OUTst.getsumsq() / nsamps;
				float dBOUTrms = (lin2dB(OUTrms) / 2.0f) - 3.0f;

				float dBINgainmax = (INst.getmaxvaldB()) / 2.0f;
				float dBINgainmin = (INst.getminvaldB()) / 2.0f;
				float dBOUTgainmax = (OUTst.getmaxvaldB()) / 2.0f;
				float dBOUTgainmin = (OUTst.getminvaldB()) / 2.0f;

				::fprintf(stderr,"S: %10lld, ", currentaudiosample);

				::fprintf(stderr,"INPUT(RMS:%+6.2fdB,%+6.2fdB), OUTPUT(RMS:%+6.2fdB,%+6.2fdB):\n",
					dBINrms - inoutrefdB,
					dBINgainmax - inoutrefdB,
					dBOUTrms - inoutrefdB,
					dBOUTgainmax - inoutrefdB);

				for (int i = 0; i < numexp; i++)
				{
					if (!isdexpand(i))
						continue;

					int niter = isxexpand(i) ? 3 : 1;

					for (int j = 0; j < niter; j++)
					{

						int ci = i + j;
						dlbystats& st(DLBYAst[ci]);

						::fprintf(stderr,
						"    "
						"DBYA%1x"
						"L(%+6.2f/%+6.2f/%+6.2f), "
						"M(%+6.2f/%+6.2f/%+6.2f), "
						"H(%+6.2f/%+6.2f/%+6.2f), "
						"h(%+6.2f/%+6.2f/%+6.2f)",
						ci,
						(st.chan[0].getminvaldB()), (st.chan[0].getavgvaldB()), (st.chan[0].getmaxvaldB()),
						(st.chan[1].getminvaldB()), (st.chan[1].getavgvaldB()), (st.chan[1].getmaxvaldB()),
						(st.chan[2].getminvaldB()), (st.chan[2].getavgvaldB()), (st.chan[2].getmaxvaldB()),
						(st.chan[3].getminvaldB()), (st.chan[3].getavgvaldB()), (st.chan[3].getmaxvaldB()));
	
						::fprintf(stderr,"\n");
					}
				}


			INst.reset();
			OUTst.reset();
			for (int i = 0; i < MAXnDLBYA; i++)
			{
				DLBYAst[i].reset();
			}

			curlongsample = 0;
			totals = 0;
		}
		cursample += 1;
		curlongsample += 1;
		currentaudiosample += 1;
	}

	void NOINLINE
	initaccumulatelevel(void)
	{
#if defined(DUMPALLINFO)
		::fprintf(stderr,"Signal output information is Avg/Peak\n");
#endif
		cursample = 0;
		curlongsample = 0;
		if (ac.info != 0)
			fprintf(stderr,"Per channel gains for each step: FREQ-RANGE(mindB, avgdB, maxdB)\n");
	}

}

//
// vi: set ts=4:
//
