#if !defined(__ACCUMINFO_H__)

#define __ACCUMINFO_H__ 1

//
// This code was originally meant just for debugging/diagnostic purposes.
// I apologize for the crappy state of this code.
//
// Frankly, the algorithms even suck!
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "itqA.h"

#if defined(LOCKCOMPSTATS)
extern pthread_mutex_t infolock;
#endif

#define INLCS
#if defined(INLCS)
#define CSINLINE
#else
#define CSINLINE __attribute__((noinline))
#endif

struct compstats
{
	float val;
	float minLIN;
	float maxLIN;
	float sumLIN;

	int count;
	float sumsqavg;
	float sumsqlavg;
	float sumsq;

	void
	calcsumsq(float newval)
	{
		float tsumsqavg = 0.002f * newval + 0.998f * sumsqavg;
		sumsqavg = tsumsqavg;

		float lsvsl = 1.0f;
		float lavg = 0.99f / lsvsl;
		float inavg = 1.0f - lavg;

		float tsumsqlavg = inavg * tsumsqavg + lavg * sumsqlavg;
		sumsqlavg = tsumsqlavg;
		sumsq += tsumsqlavg;
	}
	
public:
	compstats(void) NOINLINE : val(0.1f),
			minLIN(1000.0f), maxLIN(0.0001f), sumLIN(0.0001f), count(1),
			sumsqavg(1.0), sumsqlavg(1.0), sumsq(0.0)
			{}

	~compstats() {}

	float
	next(float newval)
	{
		if (ac.info == 0)
			return newval;

		val = newval;

		calcsumsq(newval);

		maxLIN = (newval > maxLIN) ? newval : maxLIN;
		minLIN = (newval < minLIN) ? newval : minLIN;

		sumLIN += newval;
		count++;

		float rtval = newval;

		return rtval;
	}

	float
	next(float newval, float UNUSED nv1)
	{
		return next(newval);
	}

	template <typename PV>
	PV operator()(PV input)
	{
		return next(input);
	}

	template <typename PV, typename PV2>
	PV operator()(PV input, PV2 arg2)
	{
		return next(input, arg2);
	}

	float getval(void) const
	{
		return val;
	}

	float getminval(void) const
	{
		return 	minLIN;
	}

	float getmaxval(void) const
	{
		return 	maxLIN;
	}

	float getmaxvaldB(void) const
	{
		return lin2dB(maxLIN);
	}
	
	float getminvaldB(void) const
	{
		return lin2dB(minLIN);
	}

	float getavgval(void) const
	{
		int cnt = (count > 0) ? count : 1;
		return sumLIN / float(cnt);
	}

	float getavgvaldB(void) const
	{
		return lin2dB(getavgval());
	}


	float getsumsq(void) const
	{
		return sumsq;
	}

	float getsumsqavg(void) const
	{
		return sumsqlavg;
	}

	void reset(void)
	{
		sumsq = 0.0f;
		minLIN = 1000.0f;
		maxLIN = 0.00001f;
		sumLIN = getavgval();
		count = 1;
	}

};


static constexpr int MAXnDLBYA = 20;
extern int nDLBYA;
extern compstats
	INst, OUTst;
	/* AGCOUTst, PRELIMITst, LIMoutst, limitst, flimitst ;*/


struct dlbystats
{

	using VDEF4 = TYPEvd4x1;
	using vtype4 = varrayT<VDEF4>;

	compstats chan[4];

	dlbystats() : chan() {}

	void reset(void)
	{
		for (int i = 0; i < 4; i++)
			chan[i].reset();
	}

	void next(vtype4 vals)
	{
		for (int i = 0; i < 4; i++)
			chan[i].next(vals[i]);
	}
};
	
extern dlbystats DLBYAst[MAXnDLBYA];

namespace accuminfo
{
	static inline int samplesavg(void) { return aspec.inSRATE / 10; }
	static inline int longsamplesavg(void) { return (samplesavg() * 10); }

	extern float peakvalue;
	extern float longpeakvalue;
	extern float sumvalue;
	extern float longsumvalue;
	extern int cursample;
	extern int curlongsample;
	extern int nperline;

	void NOINLINE accumulatelevel(const Asample& sample, int& totals, int& limit99, int& limit70, int& limit50, int& limit25);
	void NOINLINE initaccumulatelevel(void);

}


//
// return true if this is an expander
//
extern bool isdexpand(int);
extern bool isxexpand(int);


#endif
