
//
//
// Copyright(C) 2017 John S Dyson
// All rights reserved.
//
// This source code is an unpublished proprietary document, and is available only
// under a written license.
// 

#include <sys/types.h>

#include "itqA.h"
#include "itq-typedefs.h"
//#include "itq-qdefs.h"
#include "vecmath.h"

#if 0
//
// Each step/state is shown by the 'S' indicies
//
cq0 THQALIGNED emptyqueueS0("ReadFromFile");                 // anywhere between 0 and NAUDIOCHUNK entries inclusive
cqFILTERin THQALIGNED activefillS0("MultiFilter");           // split the audio bands
cqLIMITERin THQALIGNED activefillS2("InputToLimiter");       // Queue for the AGC processor output & Limiter input
cqFILTERin THQALIGNED activefillS3("WriteToFile");          // Queue for the input of the file write thread

ob0 THQALIGNED emptyobufqueueS0("Obuffreestack");
obqlong THQALIGNED queuetopreagcS1("InputToPreAgc");
obqlong THQALIGNED queuetoagc0S2("InputToAgc0");
obqlong THQALIGNED queuetoagc1S3("InputToAgc1");
obqlong THQALIGNED queuetopostfiltS4("InputToPF");

#define SAMPLESPERSAMPLE 8

audiochunk THQALIGNED preallocaudiochunk[NAUDIOCHUNKSXTRA];
#if 0
obufpayload THQALIGNED preallocobufpayload[NOBUFPAYLOAD];
#endif

extern void initcqs(void);

void
doqueueinits(void)
{
	initcqs();
}

void NOINLINE
dumprtqueuestats(void)
{
	::fprintf(stderr,"trad:(%d,%d,%d,%d), mb(%d,%d,%d,%d,%d)",
		emptyqueueS0.THQqcount(),
		activefillS0.THQqcount(),
		activefillS2.THQqcount(),
		activefillS3.THQqcount(),

		emptyobufqueueS0.THQqcount(),
		queuetopreagcS1.THQqcount(),
		queuetoagc0S2.THQqcount(),
		queuetoagc1S3.THQqcount(),
		queuetopostfiltS4.THQqcount()
	);
}

void NOINLINE
dumpqueuestatus(void)
{
	emptyqueueS0.dumpqueuestatus();
	activefillS0.dumpqueuestatus();
	activefillS2.dumpqueuestatus();
	activefillS3.dumpqueuestatus();
	emptyobufqueueS0.dumpqueuestatus();
	queuetopreagcS1.dumpqueuestatus();
	queuetoagc0S2.dumpqueuestatus();
	queuetoagc1S3.dumpqueuestatus();
	queuetopostfiltS4.dumpqueuestatus();
	
}

void NOINLINE
initcqs(void)
{
		for (int i = 0; i < NAUDIOCHUNKSXTRA; i++)
		{
			paudiochunk t = &preallocaudiochunk[i];
			t->setindex(i);
			emptyqueueS0.THQwqspaceandinsert(t);
		}

#if 0
		for (int i = 0; i < NOBUFPAYLOAD; i++)
		{
			pobufpayload t = &preallocobufpayload[i];
			t->setindex(i);
			emptyobufqueueS0.THQwqspaceandinsert(t);
		}
#endif
}
#endif

namespace lt
{
	//
	// print time value based upon mode flag:
	// printtsmode == 0, (sec: <seconds>, nsec: <nanoseconds>)
	// printtsmode == 1, (sec: <seconds>, usec: <microseconds>)
	// printtsmode == 2, (sec: <seconds> in floating point.
	//                    submode / 100 == width, submode%100 == decimal)
	//
	char* NOINLINE
	// printtsval(const timespec *t, int printtsmode, int submode = 0)
	printtsval(const timespec *t, int printtsmode, int submode)
	{
#if !defined(NONREENTRANT)
		if (printtsmode == 0)
		{
			char *rtval;
			::asprintf(&rtval,"sec: %ld, nsec: %ld",
				t->tv_sec, t->tv_nsec);
			return rtval;
		}
		else if (printtsmode == 1)
		{
			char *rtval;
			::asprintf(&rtval, "sec: %ld, usec: %ld",
				t->tv_sec, t->tv_nsec / 1000);
			return rtval;
		}
		else if (printtsmode == 2)
		{
			double floattime;
			floattime = t->tv_nsec;
			floattime /= 1e9;
			floattime += t->tv_sec;
			char *rtval;
			int width, decimal;
			width = submode / 100;
			if (width > 32)
				width = 32;
			decimal = submode % 100;
			if (decimal > 32)
				decimal = 32;
			::asprintf(&rtval, "sec: %*.*lf", width, decimal, floattime);
			return rtval;
		}
		else
		{
			char *rtval = ::strdup("printtsval: printtsmode is out of range");
			return rtval;
		}
#else
		static char buf[1024];

		if (printtsmode == 0)
		{
			::snprintf(buf, sizeof buf,"sec: %ld, nsec: %ld",
				(long int) t->tv_sec, (long int) t->tv_nsec);
			return buf;
		}
		else if (printtsmode == 1)
		{
			::snprintf(buf, sizeof buf, "sec: %ld, usec: %ld",
				(long int) t->tv_sec, (long int) t->tv_nsec / 1000);
			return buf;
		}
		else if (printtsmode == 2)
		{
			double floattime;
			floattime = t->tv_nsec;
			floattime /= 1e9;
			floattime += t->tv_sec;
			char *rtval;
			int width, decimal;
			width = submode / 100;
			if (width > 32)
				width = 32;
			decimal = submode % 100;
			if (decimal > 32)
				decimal = 32;
			::snprintf(buf, sizeof buf, "sec: %*.*lf", width, decimal, floattime);
			return buf;
		}
		else
		{
			char *rtval = ::strdup("printtsval: printtsmode is out of range");
			return rtval;
		}
#endif
	}

#if 0
	void
	printthreadtime(const char *msg, bool thread = true)
	{
		struct rusage ru;

		getrusage(thread ? RUSAGE_THREAD : RUSAGE_SELF, &ru);

		double secondsuser = double(ru.ru_utime.tv_sec) + double(ru.utime.tv_usec) / 1000000.0;
		double secondssys = double(ru.ru_stime.tv_sec) + double(ru.stime.tv_usec) / 1000000.0;

		::fprintf(stderr,"%s: \"%s\": user: %.8lf seconds, sys: %.lf seconds\n",
			thread ? "Thread" : "Process", msg, secondsuser, secondsyss);
	}
#endif


#if defined(LSLEEP)
	void NOINLINE
	NSsleepf(double nanosecsd)
	{
		double secsd = nanosecsd * 1.0e-9;
		int secsi64;
		asm ("cvttsd2si %1,%0" : "=r"(secsi64) : "xm"(secsd));
		int64_t secsdt = secsi64;
		double secslessthan1 = secsd - secsdt;
		double nsecslessthan1 = secslessthan1 * 1.0e9;
		int64_t nsecs = nsecslessthan1;

		struct timespec ts = {(time_t) secsdt, (long) nsecs};
		struct timespec tsrem = ts;
		struct timespec tsnext = ts;
		
		::fprintf(stderr,"NSsleepf arguments: ts.tv_sec: %ld, ts.tv_nsec: %ld\n",
			(long int) ts.tv_sec, (long int) ts.tv_nsec);

		while( nanosleep(&tsrem, &tsnext) != 0)
		{
			int eval = errno;
			if (eval == EINTR)
			{
				tsrem = tsnext;
			}
			else
			{
				perror("NSsleepf -- nanosleep");
				break;
			}
		}
	}

	void NOINLINE
	NSsleep(int64_t nanosecs)
	{
		int64_t secs = nanosecs / 1000000000 ;
		int64_t nsecs = nanosecs - (secs * 1000000000);

		struct timespec ts = {(time_t) secs, (long) nsecs};
		struct timespec tsrem = ts;
		struct timespec tsnext = ts;

		while( nanosleep(&tsrem, &tsnext) != 0)
		{
			int eval = errno;
			if (eval == EINTR)
			{
				tsrem = tsnext;
			}
			else
			{
				perror("NSsleep -- nanosleep");
				break;
			}
		}
	}
	void
	USsleep(int32_t usecs)
	{
		int64_t nsecs = usecs * 1000;
		NSsleep(nsecs);
	}

	void
	MSsleep(int32_t mssarg)
	{
		int64_t nsecs = mssarg * 1000000;
		NSsleep(nsecs);
	}

#endif
#if 1 || defined(LSLEEP)
#if defined(USETIMEOFDAY)
	bool
	gettime(timespec* ts)
	{
		struct timeval tv;
		if (gettimeofday(&tv, nullptr))
			return false;

		ts->tv_sec = tv.tv_sec;
		ts->tv_nsec = tv.tv_usec * 1000;
		return true;
	}

#else
	bool
	gettime(timespec* ts)
	{
		if( clock_gettime(CLOCK_REALTIME, ts))
			return false;
		return true;
	}
#endif
#endif

#if !defined(ONWINDOWS)
	timespec NOINLINE
	Ltimeradd_ms(const timespec* ts, int offsetmsec)
	{
		timespec localts = *ts;

		localts.tv_nsec += offsetmsec * 1000000;
		if (localts.tv_nsec >= 1000000000)
		{
			int64_t secadd = localts.tv_nsec / 1000000000;
			localts.tv_nsec %= 1000000000;
			localts.tv_sec += secadd;
		}

		return localts;
	}

	timespec NOINLINE
	Ltimeradd_ns(const timespec* ts, int offsetnsec)
	{
		timespec localts = *ts;

		localts.tv_nsec += offsetnsec;
		if (localts.tv_nsec >= 1000000000)
		{
			int64_t secadd = localts.tv_nsec / 1000000000;
			localts.tv_nsec %= 1000000000;
			localts.tv_sec += secadd;
		}

		return localts;
	}

	timespec NOINLINE
	Ltimeradd(const timespec* ts, const timespec* tsoffset)
	{
		timespec localts = *ts;

		localts.tv_nsec += tsoffset->tv_nsec;
		localts.tv_sec += tsoffset->tv_sec;
		if (localts.tv_nsec >= 1000000000)
		{
			int64_t secadd = localts.tv_nsec / 1000000000;
			localts.tv_nsec %= 1000000000;
			localts.tv_sec += secadd;
		}

		return localts;
	}

	timespec NOINLINE
	gettime_with_offset_ns(int offsetnsec)
	{
		timespec tstmp;

		if (gettime(&tstmp))
		{
			return (timespec) {0,0};
		}

		return Ltimeradd_ns(&tstmp, offsetnsec);
	}

	timespec NOINLINE
	gettime_with_offset_ms(int offsetmsec)
	{
		timespec tstmp;

		if (gettime(&tstmp))
		{
			return (timespec) {0,0};
		}

		return Ltimeradd_ms(&tstmp, offsetmsec);
	}

#endif
};


void NOINLINE
Asample::asprintf(FILE* outfile)
{
	::fprintf(outfile,"(%.2f,%.2f)", (float)sv.sva[0], (float)sv.sva[1]);
	if (++itemperline >= 16)
	{
		itemperline = 0;
		::fprintf(outfile,"\n");
		::fflush(outfile);
	}
}

char* NOINLINE
Asample::asprint(void) const
{
	char *rtval = nullptr;
//	::asprintf(&rtval,"(%.2f,%.2f)",(float)sv.sva[0],(float)sv.sva[1]);
	return rtval;
}

typedef Asample *pAsample;


void
threebytes::zero(void)
{
	b[0] = 0;
	b[1] = 0;
	b[2] = 0;
}

threebytes::threebytes(void) : b() { zero(); }

threebytes::threebytes(const threebytes &init) 
{
	b[0] = init.b[0];
	b[1] = init.b[1];
	b[2] = init.b[2];
}

threebytes&
threebytes::operator=(const threebytes& src)
{
	b[0] = src.b[0];
	b[1] = src.b[1];
	b[2] = src.b[2];
	return *this;
}

threebytes::threebytes(float av) : b()
{
	float avt0 = cvtMAXto24(av);
	static const signed long maxsigp = (1<<23);

	float avt = lm::hardlimit(avt0, float(maxsigp));

	signed long inttv = avt;

	b[0] = inttv & 0xffU;
	b[1] = (inttv >> 8) & 0xffU;
	b[2] = (inttv >> 16) & 0xffU;

}

float
threebytes::tofloat(void) const 
{
	unsigned int inttv = 0;
	signed int sinttv = 0;

	sinttv = (signed char) b[2];
	sinttv <<= 16;
	inttv = b[1];
	inttv <<= 8;
	inttv |= b[0];
	sinttv |= inttv;

	float av(sinttv);

	return cvt24toMAX(av);
}

physaudiosample24::physaudiosample24(void) : s0(), s1() {}

physaudiosample24&
physaudiosample24::operator=(const physaudiosample24& src)
{
	s0 = src.s0;
	s1 = src.s1;
	return *this;
}

void physaudiosample::dump(void) {}

void
physaudiosample::zero(void)
{
	s0 = 0;
	s1 = 0;
}

void
physaudiosample24::zero(void)
{
	s0.zero();
	s1.zero();
}

Asample& Asample::operator=(const physaudiosample& src)
{
	sv.sva[0] = src.s0;
	sv.sva[1] = src.s1;
	return *this;
}

Asample& Asample::operator= (const physaudiosamplefloat& src)
{
	sv.sva[0] = src.stereo[0];
	sv.sva[1] = src.stereo[1];
	return *this;
}

int Asample::itemperline = 0;

#if defined(__clang__)

namespace std
{
enum class align_val_t : size_t {};
};

void* __attribute__((weak))
operator new(size_t memamt, std::align_val_t alignv) 
{
	void *addr = nullptr;

	size_t atmp = int(alignv);
	if (atmp < 64)
		atmp = 64;
	posix_memalign(&addr, atmp, memamt);

	return addr;
}

void* __attribute__((weak))
operator new[](size_t memamt, std::align_val_t alignv) 
{
	void *addr = nullptr;
	size_t atmp = int(alignv);
	if (atmp < 64)
		atmp = 64;
	posix_memalign(&addr, atmp, memamt);


	return addr;
}

void __attribute__((weak))
operator delete( void * addr, std::align_val_t alignv)
{
	free(addr);
}

void __attribute__((weak))
operator delete[]( void * addr, std::align_val_t alignv)
{
	free(addr);
}
#endif

	

//
// vim: set ts=4:
//

