#if !defined(__ITQA__)
#define __ITQA__ 1


#undef _GNU_SOURCE 
#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <errno.h>
//#include <math.h>
#include <string.h>
#include <signal.h>
#include <sys/time.h>
#if !defined(WINDOWS64)
#include <sys/resource.h>
#endif

#include <vector>
#include <list>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <memory>

#include <xmmintrin.h>
/*
#include <pmmintrin.h>
#include <immintrin.h>
#include <gc_cpp.h>
*/
#include <curses.h>

//
// This was a 'garbage collection' experiment.
// decided that it isn't worth overhead.
//
#define GCQ

#include <math.h>

using std::queue;
using std::vector;
using std::list;
using std::map;
using std::stack;

#if defined(__clang__) && !defined(CLANG)
typedef unsigned int uint32_t;
typedef unsigned long int uint64_t;
#endif

#if defined(__GNUC__) && (__GNUC__ > 5)
#define NOINLINE __attribute__((noinline,noclone))
#define ALWAYS_INLINE __attribute__((always_inline))
#else
#define NOINLINE __attribute__((noinline))
#define ALWAYS_INLINE 
#endif

#define INLINE inline
#define UNUSED __attribute__((unused))
#define NOCLONE /* __attribute__((noclone)) */

static constexpr size_t threadstacksize = 4096 * 1024;
static constexpr size_t threadstackguardsize = 256 * 1024;

extern int NOINLINE create_thread(pthread_t *newthreadid, void *(*thfunc)(void *), void *threadarg);

#define AUDIOPROC

const static int dBMULTIFILTERSIZE = 16;
const static int SHORTMULTIFILTERSIZE = 16;
const static int MULTIFILTERSIZE = 24;
const static int INPMULTIFILTERSIZE = 32;
const static int HRINPMULTIFILTERSIZE = 40;

#if !defined(O_BINARY)
#define O_BINARY 0
#endif

#define MAXTMPSTR 512


//
// HOWEVER, because of the seperate multi-frequency split code,
// we need to have larger buffers to be efficient.  There isn't a current
// scheme for differing buffer sizes, so the best compromise for higher leve
// and lower level (the queue code & cache) performance, it appears that
// 2048 is the best size.  Perhaps a non-power of two is better, but
// havent' verified that the code works with a non-power of two buffer
// size.
//
// For queue elements -- the '13' below is the number of potentially
// outstanding queue buffers being filled for all of the threads added
// together.  NAUDIOCHUNKS is the total number of 'sets' of buffers
// that are available.  Aftger careful benchmarking, I have found
// that '3' is best.  '2' works well, but there are more wakeups.
// Need to verify why '2' causes more wakeup activity than '3'.
//

static constexpr int AUDIOCHUNKSIZE = 4096;


//
// the '8' is just slop
//

UNUSED constexpr int RAINBUFSIZE = AUDIOCHUNKSIZE;
UNUSED constexpr int RAOUTBUFSIZE = AUDIOCHUNKSIZE;
UNUSED constexpr int emsgbufsize = 512;
UNUSED constexpr int NSMLBUF=AUDIOCHUNKSIZE;


UNUSED constexpr double TWO24 = (16777218.0f / 2);
UNUSED constexpr double TWO30 = (1<<29);
UNUSED constexpr double MAXFLOAT16 = 32767.0f;
UNUSED constexpr double MINFLOAT16 = -32768.0f;
UNUSED constexpr double MAXFLOAT24 = TWO24-1;
UNUSED constexpr double MINFLOAT24 = -TWO24;
UNUSED constexpr double MAXFLOAT30 = TWO30-1;
UNUSED constexpr double MINFLOAT30 = -TWO30;
UNUSED constexpr double MMAXFLOAT = 1.0f;
UNUSED constexpr double MMINFLOAT = -1.0f;
UNUSED constexpr double FLOAT16TO24 = MINFLOAT24 / MINFLOAT16;
UNUSED constexpr double FLOAT24TO16 = MINFLOAT16 / MINFLOAT24;
UNUSED constexpr double FLOAT16TOMAX = MMINFLOAT / MINFLOAT16;
UNUSED constexpr double FLOATMAXTO16 = MINFLOAT16 / MMINFLOAT;
UNUSED constexpr double FLOAT24TOMAX = MMINFLOAT / MINFLOAT24;
UNUSED constexpr double FLOATMAXTO24 = MINFLOAT24 / MMINFLOAT;

static UNUSED float
cvtMAXto24(float in)
{
	return float(double(in) * FLOATMAXTO24);
}

static UNUSED float
cvt24toMAX(float in)
{
	return float(double(in) * FLOAT24TOMAX);
}

static UNUSED float
cvtMAXto16(float in)
{
	return float(double(in) * FLOATMAXTO16);
}

static UNUSED float
cvt16toMAX(float in)
{
	return float(double(in) * FLOAT16TOMAX);
}

static UNUSED float
cvt24to16(float in)
{
	return float(double(in) * FLOAT24TO16);
}

static UNUSED float
cvt16to24(float in)
{
	return float(double(in) * FLOAT16TO24);
}

#define AALIGN __attribute__((aligned(32)))
#define ALIGN __attribute__((aligned(32)))

//
// Full scale signal (for signed 24bit)
//
UNUSED constexpr double GBLfslevel = MMAXFLOAT;
UNUSED constexpr float GBLminfloat=-1.0e-19f; 	// 0.50 of the log dynamic range of the number system.

typedef float HFCFTYPE;

typedef float v4sf __attribute__((vector_size(16)));
typedef float v2sf __attribute__((vector_size(8)));

typedef union {
	v2sf svv;
	float sva[2];
} sv_phys_t;

typedef union {
	v4sf svv;
	float sva[4];
} sv_t;

static UNUSED inline ALWAYS_INLINE float minf(float v0, float v1)
{
	return (v0 < v1) ? v0 : v1;
}

static UNUSED inline ALWAYS_INLINE float maxf(float v0, float v1)
{
	return (v0 > v1) ? v0 : v1;
}
static UNUSED inline ALWAYS_INLINE float absf(float v)
{
	return (v > 0.0f) ? v : (-1.0f*v);
}

//
// Control word manipulaton
// ------------------------
// The MXCSR control word has the following bits:
//  0:    Invalid Operation Flag
//  1:    Denormal Flag (=subnormal)
//  2:    Divide-by-Zero Flag
//  3:    Overflow Flag
//  4:    Underflow Flag
//  5:    Precision Flag
//  6:    Denormals Are Zeros (=subnormals)
//  7:    Invalid Operation Mask
//  8:    Denormal Operation Mask (=subnormal)
//  9:    Divide-by-Zero Mask
// 10:    Overflow Mask
// 11:    Underflow Mask
// 12:    Precision Mask
// 13-14: Rounding control
//        00: round to nearest or even
//        01: round down towards -infinity
//        10: round up   towards +infinity
//        11: round towards zero (truncate)
// 15: Flush to Zero


// Function get_control_word:
// Read the MXCSR control word
static UNUSED inline uint32_t get_control_word()
{
    return _mm_getcsr();
}

// Function set_control_word:
// Write the MXCSR control word
static UNUSED inline void set_control_word(uint32_t w)
{
    _mm_setcsr(w);
}

// Function no_subnormals:
// Set "Denormals Are Zeros" and "Flush to Zero" mode to avoid the extremely
// time-consuming denormals in case of underflow
static UNUSED inline void no_subnormals()
{
    uint32_t t1 = get_control_word();
    t1 |= (1 << 6) | (1 << 15);     // set bit 6 and 15 in MXCSR
    set_control_word(t1);
}

// Function reset_control_word:
// Set the MXCSR control word to the default value 0x1F80.
// This will mask floating point exceptions, set rounding mode to nearest (or even),
// and allow denormals.
static UNUSED inline void reset_control_word()
{
    set_control_word(0x1F80);
}

#if defined(NOSYSPOW10)

#if defined(NOSYSPOWF)
static UNUSED inline float powf(float x)
{
	return pow(10.0, (double) x);
}
#endif

static UNUSED inline double pow10(double x)
{
	return pow(10.0, x);
}

static UNUSED inline float pow10f(float x)
{
	return powf(10.0f, x);
}

#endif


#define LDBCVATTR __attribute__((pure, unused, noinline))
#define LDBCVTYPE static

//#define LDBCVATTR __attribute__((pure, unused))

//
// Set X86 FP mode for minimal trap overheads.
//
void
static UNUSED inline setfpmode(void)
{
	_mm_setcsr(0x9fc0);
}

static UNUSED inline uint64_t 
rdtsc(void)
{
	uint64_t rslt;
	int rta, rtb, rtc, rtd;
	asm volatile("cpuid" : "=a"(rta), "=b"(rtb), "=c"(rtc), "=d"(rtd) : "a"(0) : "memory", "cc");
	asm ("rdtsc" : "=A"(rslt) : : "memory","cc");
	return rslt;
}


struct thread_init_list
{
    void *(*subr)(const void *);
    int index;
    const char *threadname;
    pthread_mutex_t thread_local_mutex;
    pthread_cond_t thread_local_cond;
    bool startok;
    int EXITrtval;
};

namespace lt
{
	extern char* printtsval(const timespec *t, int printtsmode, int submode = 0);
#if defined(LSLEEP)
	extern void NOINLINE NSsleepf(double nanosecsd);
	extern void NOINLINE NSsleep(int64_t nanosecs);
	extern void USsleep(int32_t usecs);
	extern void MSsleep(int32_t mssarg);
#endif
	extern bool gettime(timespec* ts);
	extern timespec NOINLINE Ltimeradd_ms(const timespec* ts, int offsetmsec);
	extern timespec NOINLINE Ltimeradd_ns(const timespec* ts, int offsetnsec);
	extern timespec NOINLINE Ltimeradd(const timespec* ts, const timespec* tsoffset);
	extern timespec NOINLINE gettime_with_offset_ns(int offsetnsec);
	extern timespec gettime_with_offset_ms(int offsetmsec);
}

// void threads_start(void);
// void wait_all_threads(void);

constexpr int MAXMERGEIDX = 9;

static float dB2lin(float);
static float lin2dB(float);

inline UNUSED float atoff(const char *str)
{
	return float(::atof(str));
}


struct dBsparam
{
	float dBs;

dBsparam(void) : dBs(1.0f) {}

dBsparam(float val) : dBs(val) {}

void UNUSED set(float val)
	{
		dBs = val;
	}

float UNUSED get(void) const
	{
		return dBs;
	}
};

struct disparam
{
	unsigned long miscbits;

disparam(void) : miscbits(0UL) {}

disparam(unsigned long bits) : miscbits(bits & 0xff) {}

void UNUSED set(unsigned long bits)
	{
		miscbits = bits & 0xff;
	}

unsigned long UNUSED get(void) const
	{
		return miscbits & 0xff;
	}
};

struct miscparam
{
	unsigned long miscbits;

miscparam(void) : miscbits(0UL) {}

miscparam(unsigned long bits) : miscbits(bits) {}

void UNUSED set(unsigned long bits)
	{
		miscbits = bits;
	}

unsigned long UNUSED get(void) const
	{
		return miscbits;
	}
};

struct gainparam
{
	float lin; /* linear value */
	float dB; /* dBvalue */

gainparam(void) : lin(1.0), dB(0.0) {}

gainparam(float gaindB) : lin(dB2lin(gaindB)), dB(gaindB) {}

void UNUSED setdB(float dBval)
	{
		dB = dBval;
		lin = dB2lin(dBval);
	}

void UNUSED setlin(float linval)
	{
		dB = lin2dB(linval);
		lin = linval;
	}

float UNUSED getdB(void) const
	{
		return dB;
	}

float getlin(void) const
	{
		return lin;
	}
};

//
// Convert compression ratio to the power law
//
static UNUSED float
cvtcrtor(float cr)
{
/*
	if (cr <= 1.0f)
		return 0.0f;
*/
	
	return 1.0f - (1.0f / cr);
}

//
// Convert the power law to compression ratio
//

static UNUSED float
cvtrtocr(float powerlawA)
{
	float powerlaw = powerlawA;
	if (powerlaw > 0.9999f)
		powerlaw = 0.9999f;
	return 1.0f/(1.0f - powerlaw);
}

struct cratioparam
{
	float cratio;
	float pwr;

	cratioparam(void) : cratio(1.0), pwr(0.0) {}

	void
	setcratio(float cr)
	{
/*
		if (cr < 1.0f)
			cr = 1.0f;
*/
		cratio = cr;
		pwr = cvtcrtor(cr);
	}

	void
	setpower(float pr)
	{
		cratio = cvtrtocr(pr);
		pwr = pr;
	}

	float
	getcratio(void) const
	{
		return cratio;
	}

	float
	getpower(void) const
	{
		return pwr;
	}
};

struct thresholdparam
{
	float dBthresh;
	float thresh;
thresholdparam(void) :
	dBthresh(lin2dB(GBLfslevel)-6.0f), thresh(dB2lin(dBthresh)) {}

thresholdparam(float dBval) :
	dBthresh(lin2dB(GBLfslevel) + dBval), thresh(dB2lin(dBthresh)) {}

	void setdBthresh(float dBval)
	{
		dBthresh = lin2dB(GBLfslevel) + dBval;
		//thresh = float(GBLfslevel * double(dB2lin(dBval)));
		thresh = float(GBLfslevel) * dB2lin(dBval);
/*
		fprintf(stderr,"setdBthresh: %f, %f\n", dBthresh, thresh);
*/
	}

	void setlinthresh(float linval)
	{
		dBthresh = lin2dB(linval);
		thresh = linval;
/*
		fprintf(stderr,"setlinthresh: %f, %f\n", dBthresh, thresh);
*/
	}

	float getrelativedB(void) const
	{
		float reldB = dBthresh - lin2dB(GBLfslevel);
/*
		fprintf(stderr,"getrelativedB: %f, %f, reldB: %f\n", dBthresh, thresh, reldB);
*/
		return reldB;
	}

	float getabsolutedB(void) const
	{
		float absdB = lin2dB(thresh);
/*
		fprintf(stderr,"getabsolutedB: %f, %f, absdB: %f\n", dBthresh, thresh, absdB);
*/
		return absdB;
	}

	float getlinthresh(UNUSED const char *msg = nullptr) const
	{
/*
		if (msg != nullptr)
			fprintf(stderr,"getlinthresh(\"%s\"): %f, %f\n", msg, dBthresh, thresh);
		else
			fprintf(stderr,"getlinthresh: %f, %f\n", dBthresh, thresh);
*/
		return thresh;
	}
};

struct speedparam
{
	float speed;

	speedparam(void) : speed(5.0f) {}

	speedparam(float Aspeedval) : speed(5.0f)
	{
		float speedval = Aspeedval;
//		if (speedval < 1.0f)
//			speedval = 1.0f;

		speed = speedval;
	}

	float
	getspeed(void) const
	{
		return speed;
	}

	void
	setspeed(float Aspeedval)
	{
		float speedval = Aspeedval;
//		if (speedval < 1.0)
//			speedval = 1.0;

		speed = speedval;
	}
};

enum class AGCUNIT {
	ALL = -2,			// special 'all' argument for some parameters
	INVALID = -1,		// error return
	INPUT = 0,			// Input gain -- not included in stats
	PREAGC0 = 1,		// Slow attack/release to get signal in the right range (very optional)
	PREAGC1 = 2,		// Main dual band preagc (optional, likely very desirable)
	PREAGC2 = 3,		// Secondary, post dual band preagc (optional, but probably desirable)
	AGC = 4,			// Main multi-band AGC
	AGC1 = 5,			// Secondary, fast multi-band AGC -- not used for much depth
	PRELIMIT = 6,		// Prelimit, softer than limiter,
	LIMIT = 7,			// Hard limit
	OUTPUT = 8,			// Output gain -- not included in most stats
	EX0 = 9,			// Expander 0 -- before PREAGC0
	EX1 = 10,			// Expander 1 -- front inside of matrix
	EX2 = 11,			// Expander 2 -- rear inside of matrix
	UNITCOUNT = 12
};

//
// This names MUST match the above AGCUNIT enums -- except there is an offset of 'ALL'
// whatever that is :-).
//
constexpr const char * const RAWagcunitnames[] =
{
	"all", "invalid", "input", "preagc0", "preagc1", "preagc2",
	"agc", "agc1", "prelimit", "limit", "output", "ex0", "ex1", "ex2",
	"unitcount"
};

static const char *
agcunitnames(AGCUNIT id)
{
	int nameindex = int(id) - int(AGCUNIT::ALL);
	if (nameindex >= (int(AGCUNIT::UNITCOUNT) - int(AGCUNIT::ALL)))
	{
		return agcunitnames(AGCUNIT::INVALID);
	}

	return RAWagcunitnames[int(id)];
}

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Weffc++"

//
// Argument processing and storage
//
struct arg_context
{
    char *infile;
    char *outfile;
    FILE *outfp;
    FILE *infp;
	int rafloatout;
	int rafloat;
    int info;
	float outgain;
	bool quiet;
};

extern struct arg_context ac;

#pragma GCC diagnostic pop


extern void *thread_readaudio_0A(const void *);
extern void *thread_filter_0B(const void *);
extern void *thread_preagc_0C(const void *);
extern void *thread_agc_1A(const void *);
extern void *thread_agc_1B(const void *);
extern void *thread_postfilt_1C(const void *);
extern void *thread_limiter_2A(const void *);
extern void *thread_writeaudio_3A(const void *);

extern void dumpqueuestatus(void);
extern void initallmodes(void);

extern void initfilters(void);
extern void deletefilters(void);

extern const char* lstrerror_r(int errcode, char *bufarg, int bufargsize);

namespace lt
{
	static void __attribute__((unused, noinline))
	printthreadtime(const char *msg, bool thread = true)
	{
#if 0
		struct rusage ru;

		getrusage(thread ? RUSAGE_THREAD : RUSAGE_SELF, &ru);

		double secondsuser = double(ru.ru_utime.tv_sec) + double(ru.ru_utime.tv_usec) / 1000000.0;
		double secondssys = double(ru.ru_stime.tv_sec) + double(ru.ru_stime.tv_usec) / 1000000.0;

		fprintf(stderr,"%s: %-10.10s: user: %.6lf seconds, sys: %.6lf seconds\n",
			thread ? "Thread" : "Process", msg, secondsuser, secondssys);
#endif
	}

};

static UNUSED void
write64(void *dst, void *src)
{
	long long litemp;
	litemp = * (long long *) src;
	asm ("movnti %1,%0" : "=m"(* (long int *) dst) : "r"(litemp));
}

extern void siglevelAVGinit(void);

static constexpr float baseSRATE = 44100.0f;
struct audiospec
{
	int inSRATE;
	float SRATETMULT;
	float SRATETDIV;
public:
	audiospec(int srate = 44100) :
		inSRATE(srate), SRATETMULT(baseSRATE/float(srate)), SRATETDIV(float(srate)/baseSRATE) {}

	void
	change(int srate)
	{
		inSRATE = srate;
		SRATETMULT = baseSRATE / float(srate);
		SRATETDIV = 1.0f / SRATETMULT;
	}
};

extern audiospec aspec;


static UNUSED inline void
prefetchnta(void *addr)
{
	asm volatile("prefetchnta %0" : :"rm"(*(char *)addr));
}

static UNUSED inline void
prefetcht0(void *addr)
{
	asm volatile("prefetcht0 %0" : :"rm"(*(char *)addr));
}

extern void setsignal(void);
extern void forcettyupdate(void);


template <typename PVAL>
class uniquecall : public std::unique_ptr<PVAL>
{
	using me = uniquecall<PVAL>;
	using myup = typename std::unique_ptr<PVAL>;
	using myupp = myup *;
	using pvp=PVAL *;
public:
	uniquecall(void) : std::unique_ptr<PVAL>()
	{
	}

	uniquecall(PVAL* p) : std::unique_ptr<PVAL>(p)
	{
	}

	~uniquecall()
	{
		delete myupp(this)->release();
	}

	void
	dodelete(void)
	{
		delete myupp(this)->release();
	}

	me&
	operator=(PVAL* init)
	{
		myup::operator=(myup(init));
		return *this;
	}

	operator pvp()
	{
		return myupp(this)->get();
	}

	template <typename A0>
	A0 next(const A0& src)
	{
		return (myupp(this)->get())->next(src);
	}

	template <typename A0, typename A1>
	A0 next(const A0& src0, const A1& src1)
	{
		return (myupp(this)->get())->next(src0, src1);
	}

	template <typename A0, typename A1, typename A2>
	A0 next(const A0& src0, const A1& src1, const A2& src2)
	{
		return (myupp(this)->get())->next(src0, src1, src2);
	}

	template <typename CALLANDRTN>
	CALLANDRTN operator()(const CALLANDRTN& v)
	{
		return (myupp(this)->get())->next(v);
	}
};

namespace threadresource
{
	extern void resourcewait(void);
	extern void resourcefree(void);
	extern void waitforspeed(void);
	extern void speedready(void);
	extern void speedreadyonce(void);
	extern void speedreadyreset(void);
};

extern int numthreads;

#endif

//
// vim: set ts=4:
//

